# Dynamic linking

Why dynamic linking is better? Create an alternative implementation of `libpnm` and use
it without recompiling the (dynamically linked) executable.

```sh
make
pushd pnm-info
./pnm-monolit-info ../../torony-o.ppm
LD_LIBRARY_PATH=../libpnm:$LD_LIBRARY_PATH ./pnm-monolit-info ../../torony-o.ppm
LD_LIBRARY_PATH=../alterlib:$LD_LIBRARY_PATH ./pnm-monolit-info ../../torony-o.ppm
popd
pushd pnm-monolit-manipulate
LD_LIBRARY_PATH=../libpnm:$LD_LIBRARY_PATH ./pnm-monolit-manipulate ../../torony-o.ppm -PPM inverted.ppm -i
LD_LIBRARY_PATH=../alterlib:$LD_LIBRARY_PATH ./pnm-monolit-manipulate ../../torony-o.ppm -PPM alternative.ppm -i
popd
make clean
```
